/*
ライセンスについて

以下の条件に従う限り、著作権者に許諾を得ることなく、
誰でも自由に使用・複製・改変・配布することを許可します。

・現状のまま提供するものであり、著作権者は、なんらの保証はしない。
・何が起ころうとも自己責任で行う。
・改変したものを配布する場合には、それまでの著作権表示を削除せず、このライセンスも継承する。
・新たな著作権表示は、それまでの著作権表示の上の行に付け足していく。
・ファイルの冒頭部分にライセンスを表示する。


Copyright (c) 2018 Shinichi Takehara

*/

function caption_stat() {
	
	//File APIをサポートしてるかのチェック
	if (window.File && window.FileReader && window.FileList && window.Blob) {
		
		var reader = new FileReader();
		
		//選択されたファイルを取得
		var file = document.getElementById("selectedFile").files[0];
		
		//ファイルを読み込む。IPtalkの入力記録の文字コードはShift_JIS
		reader.readAsText(file, "Shift_JIS");
		
		//*****************************
		//**********　各種設定　**********
		//*****************************
		
		// ↓↓↓↓↓↓↓↓↓↓ 変更しても良い項目 始まり ↓↓↓↓↓↓↓↓↓↓
		
		//入力間隔（秒）
		//数値の小さい順に並べる。最後の"対象外"は変更しないように。
		var aryRank = [3, 6, 10, 30, 60, 180, "対象外"];
		
		//入力間隔ごとのマーク
		var aryMarkSet = ["☆", "◎", "○", "△", "▲", "▼", "※"];
		
		//入力間隔・マークは7個で固定
		//個数を変える場合には、関連部分のスクリプトを書き換える必要あり
		
		//IPアドレス匿名化用。9人までしか想定していない
		var aryAnon = 
		["Aさん","Bさん","Cさん","Dさん","Eさん","Fさん","Gさん","Hさん","Iさん"];
		
		//除外する文字列（正規表現）
		//これ以外の文字列を除外する場合は、ここに正規表現で追加する
		var aryException = [
		/^\$改行\$/ ,
		/^（ＤＥＬ）/ , 
		/^（連絡）/ , 
		/^（Ｕｎｄｏ/];
		
		//出力されるファイルの文字列の色（入力者別の文字色）を変える場合は
		//「#以降の数字部分」を書き換える
		var strCSS1 = "<style>\r\n" +
		".color0{ color : #005295; }\r\n" +
		".color1{ color : #1b7d37; }\r\n" +
		".color2{ color : #8a1310; }\r\n" +
		".color3{ color : #67a7bd; }\r\n" +
		".color4{ color : #ff0000; }\r\n" +
		".color5{ color : #ca6720; }\r\n" +
		".color6{ color : #0000ff; }\r\n" +
		".color7{ color : #c0688a; }\r\n" +
		".color8{ color : #000000; }\r\n";
		
		// ↑↑↑↑↑↑↑↑↑↑ 変更しても良い項目 終わり ↑↑↑↑↑↑↑↑↑↑
		
		
		
		var comma1 = 0; //文字列を3分割する時に使う
		var comma2 = 0;
		
		var i = 0;
		var j = 0;
		var k = 0;
		var x = 0;
		var y = 0;
		
		var aryTime = []; //時刻（ミリ秒）
		var aryTempTime = []; //時刻部分をミリ秒に変換するための一時的な配列
		
		var aryIPAddress = []; //IPアドレス
		var aryStrings = []; //入力文字列
		var aryNumberOfCharacters = []; //各入力の文字数
		
		//最初の入力は「対象外」なので、配列0番目に入れておく
		var aryDeltaT = ["対象外"]; //入力間隔（秒）
		var aryMark = ["※"]; //入力間隔のマーク
		
		var aryCaptioner = []; //入力者数
		
		
		var radioMark = document.getElementsByName("mark");
		var isMark; //出力時にマークを付けるかどうか
		
		
		var isAnon = document.getElementById("anon").checked; //チェックが入っていれば（trueなら）匿名化
		var aryTempAnon = [];
		
		var aryTempException = []; //除外する文字列かどうかの判定用
		
		//統計処理用
		var aryPersonalData = []; //入力者各自のデータ格納用
		
		var strTotalTime; //入力時間合計（時分秒）
		var t1 = 0;
		var t2 = 0; //入力時間合計（ミリ秒）
		var t3 = 0;
		var t4 = 0;
		var t5 = 0;
		var totalTime_ms = 0; //入力時間合計（ミリ秒）
		
		var totalCaracter = 0; //入力文字数合計
		var totalInput = 0; //入力回数合計
		var charPerMinute = 0; //1分当たりの文字数
		var averageTime = 0; //平均入力間隔
		var charPerInput = 0; //入力1回当たりの平均表示文字数
		
		var isUndo; //Undoが連続で繰り返された場合の「Undo対象となった文字列」特定用
		
		var subTotal = 0; //小計
		var percentage = 0; //入力回数等の割合
		
		
		//**********HTML書き出し用**********
		var outputStrings = "";
		
		//---------- 入力者ごとの色 ----------
		var spanColor = [
		"<span class=\"color0\">", 
		"<span class=\"color1\">", 
		"<span class=\"color2\">",
		"<span class=\"color3\">",
		"<span class=\"color4\">",
		"<span class=\"color5\">",
		"<span class=\"color6\">",
		"<span class=\"color7\">",
		"<span class=\"color8\">"];
		
		
		var now = new Date();
		
		//タイトルは「JavaScriptを実行した日時」を元に作成
		var strHeader = 
		"<!doctype html>\r\n" +
		"<html>\r\n" +
		"<head>\r\n" +
		"<meta charset=\"UTF-8\">\r\n" +
		"<title>" + 
		now.getFullYear() + "_" + ( now.getMonth() + 1 ) + "_" + now.getDate() + "_" +
		now.getHours() + "_" + now.getMinutes() + "_" + now.getSeconds() + 
		"_入力記録.html</title>\r\n" +
		"</head>\r\n\r\n" ;
		
		//---------- CSS後半 ----------
		var strCSS2 =
		"div{ margin : 20px 10px; }\r\n" +
		"table{ text-align : right; border-collapse : collapse; border : solid 1px; }\r\n" +
		"th,td{ padding : 5px 10px; border : solid 1px #000000; }\r\n" +
		".center{ text-align : center; }\r\n" +
		"</style>\r\n\r\n";
		//--------------------------
		
		var strBodyStart = 
		"<body>\r\n" +
		"<p>\r\n" ;
		
		//表作成用
		var strTable1 = "";
		var strTable2 = "";
		var strTable3 = "";
		var strTable4 = "";
		
		var who = 0; //入力者ごとに色付けする用
		
		
		//*****************************
		//*****************************
		//*****************************
		
		
		//ファイルを読み込んだ後の処理
		reader.onload = function(evt) {
			
			//読み込んだテキストを1行ずつ配列に入れる
			var aryRawText = reader.result.split(/\r\n/g);
			
			
			//**********時刻、IPアドレス、文字列に3分割して配列に入れる**********
			for( i=0 ; i < aryRawText.length ; i++ ) {
				
				if( aryRawText[i] === "" ) {
					//空行ならスキップ
				} else if( /^[0-9]{4}\/[0-9]{2}\/[0-9]{2}-/.test(aryRawText[i]) ) {
					//満員通知行もスキップ。満員通知の例↓
					//2018/08/20-10:49:05:満員通知受信：10.30.5.109,10.30.5.110,Xさん,Ful
				} else if( /^[0-9]{1,2}:[0-9]{1,2}:[0-9]{1,2}:[0-9]{1,3}/.test(aryRawText[i]) ) {
					//時刻で始まっている（普通の入力）場合
					
					comma1 = aryRawText[i].indexOf(",");
					comma2 = aryRawText[i].indexOf("]");
					
					//----------時刻をミリ秒に変換して格納----------
					aryTempTime = aryRawText[i].slice(0,comma1).split(":");
					
					aryTime[j] = 
					aryTempTime[0]*60*60*1000 + 
					aryTempTime[1]*60*1000 + 
					aryTempTime[2]*1000 + 
					aryTempTime[3]*1;
					//----------------------------------------
					
					aryIPAddress[j] = aryRawText[i].slice(comma1+2,comma2); //IPアドレスを格納
					aryStrings[j] = aryRawText[i].slice(comma2+2); //文字列を格納
					
					j++;
				} else {
					//文字列のみの行の処理
					//1つ前の配列に文字列を加える
					aryStrings[j-1] = aryStrings[j-1] + aryRawText[i];
				}
			}
			//********************************************************
			
			
			//IPアドレスの重複なしの配列 = 入力者のリスト
			aryCaptioner = Array.from(new Set(aryIPAddress));
			
			//----------IPアドレス匿名化処理----------
			if( isAnon ) {
				for( i = 0 ; i < aryIPAddress.length ; i++ ) {
					aryIPAddress[i] = aryAnon[ aryCaptioner.indexOf(aryIPAddress[i]) ];
				}
				aryCaptioner = Array.from(new Set(aryIPAddress));
			}
			//------------------------------------
			
			
			//----------入力間隔の計算----------
			aryDeltaT[0] = 0;
			
			for( i = 1 ; i < aryTime.length ; i++ ) {
				aryDeltaT[i] = ( aryTime[i] - aryTime[i-1] ) / 1000;
				//↓F12での送出した場合の処理
				if( aryDeltaT[i] === 0 ) {
					aryDeltaT[i] = aryDeltaT[i - 1];
				}
			}
			//F12キーで文字列を送出すると、「$改行$」+「文字列」の2つの入力として扱われるが、
			//2つの入力は「同時刻」となり「文字列」のほうの入力間隔が0になる。
			//1番最初の入力を除くと入力間隔が0になるのは、F12で送出した場合のみなので
			//「文字列」の入力間隔を「$改行$」の入力間隔に置き換える
			//-------------------------------
			
			
			//----------入力間隔マークを付けるかどうか----------
			// isMark が1ならマーク付与、2なら秒数付与、3なら何も付けない
			for( i = 0 ; i < radioMark.length; i++ ) {
				if( radioMark[i].checked ) {
					isMark = radioMark[i].value;
					break;
				}
			}
			//-------------------------------------------
			
			
			//----------文字数カウント----------
			for( i = 0 ; i < aryStrings.length ; i++ ) {
				
				//除外する文字列にマッチするか判定。
				//マッチすれば 1（true）、しなければ 0（false）。
				for( j = 0 ; j < aryException.length ; j++) {
					aryTempException[j] = aryException[j].test(aryStrings[i]);
				}
				
				var sum = 0;
				
				//除外する文字列のいずれにもマッチしなければ sum = 0 になる
				for (j = 0 ; j < aryException.length ; j++) {
					sum = sum + aryTempException[j];
				}
				
				if (sum === 0 )
					aryNumberOfCharacters[i] = aryStrings[i].length;
				else
					aryNumberOfCharacters[i] = 0;
			}
			//------------------------------
			
			//準備完了
			//aryTime, aryIPAddress, aryStrings, aryCaptioner, aryDeltaT, aryNumberOfCharacters
			
			
			
			//----------入力間隔ごとのマーク----------
			//「入力間隔マーク」での選択によらず、ここでは、マークを付与しておき
			//HTML出力処理のところで「秒数」や「マーク無し」の処理をする
			for( i = 1 ; i < aryDeltaT.length ; i++ ) {
				if( aryNumberOfCharacters[i] === 0 ) {
					aryMark[i] = "";
				} else if( 0 < aryDeltaT[i] && aryDeltaT[i] <= aryRank[0] ) {
					aryMark[i] = aryMarkSet[0];
				} else if( aryRank[0] < aryDeltaT[i] && aryDeltaT[i] <= aryRank[1] ) {
					aryMark[i] = aryMarkSet[1];
				} else if( aryRank[1] < aryDeltaT[i] && aryDeltaT[i] <= aryRank[2] ) {
					aryMark[i] = aryMarkSet[2];
				} else if( aryRank[2] < aryDeltaT[i] && aryDeltaT[i] <= aryRank[3] ) {
					aryMark[i] = aryMarkSet[3];
				} else if( aryRank[3] < aryDeltaT[i] && aryDeltaT[i] <= aryRank[4] ) {
					aryMark[i] = aryMarkSet[4];
				} else if( aryRank[4] < aryDeltaT[i] && aryDeltaT[i] <= aryRank[5] ) {
					aryMark[i] = aryMarkSet[5];
				} else {
					aryMark[i] = aryMarkSet[6];
				}
			}
			//-----------------------------------
			
			
			
			
			
			//****************************
			//********** 統計処理 **********
			//****************************
			
			
			//----------（入力者数 + 2）×（ 1 + rankの数×3 +5 ） の配列を初期化----------
			//4人の場合、縦6、 横( 1 + 7×3 + 5 ) の配列
			//[入力者1][rank1の回数][rank1の文字数][rank1の時間合計]...
			//...[対象外回数][対象外の文字数][対象外の時間合計]
			//[F9の回数][F9の文字数][F11の回数][F11の文字数][各自の入力回数合計]
			//...
			//[入力者n][rank1の回数][rank1の文字数][rank1の時間合計]...
			//
			//[小計][rank1の回数][rank1の文字数][rank1の時間合計]...[F9の回数][F9の文字数][F11の回数][F11の文字数][]
			//[割合][rank1の回数][rank1の文字数][rank1の時間合計]...[F9の回数][F9の文字数][F11の回数][F11の文字数][]
			for( y = 0 ; y < aryCaptioner.length + 2 ; y++ ) {
					aryPersonalData[y] = new Array(aryRank.length *3 + 6);
				for( x = 0 ; x < aryRank.length * 3 + 6; x++ ) {
					aryPersonalData[y][x] = 0;
				}
			}
			//-----------------------------------------------------------
			
			
			//----------入力者ごとの文字数、入力回数、入力時間を配列に格納----------
			x = 0;
			y = 0;
			
			//左端の列に入力者を格納
			for( i = 0 ; i < aryCaptioner.length ; i++ ) {
				aryPersonalData[i][0] = aryCaptioner[i]; 
			}
			
			//ランクごとの数値を格納
			for( i = 0 ; i < aryTime.length ; i++ ) {
				y = aryCaptioner.indexOf(aryIPAddress[i]);
				
				switch( aryMark[i] ) {
					case aryMarkSet[0]:
						aryPersonalData[y][1] = aryPersonalData[y][1] + 1;
						aryPersonalData[y][2] = aryPersonalData[y][2] + aryNumberOfCharacters[i];
						aryPersonalData[y][3] = aryPersonalData[y][3] + aryDeltaT[i];
					break;
					
					case aryMarkSet[1]:
						aryPersonalData[y][4] = aryPersonalData[y][4] + 1;
						aryPersonalData[y][5] = aryPersonalData[y][5] + aryNumberOfCharacters[i];
						aryPersonalData[y][6] = aryPersonalData[y][6] + aryDeltaT[i];
					break;
					
					case aryMarkSet[2]:
						aryPersonalData[y][7] = aryPersonalData[y][7] + 1;
						aryPersonalData[y][8] = aryPersonalData[y][8] + aryNumberOfCharacters[i];
						aryPersonalData[y][9] = aryPersonalData[y][9] + aryDeltaT[i];
					break;
					
					case aryMarkSet[3]:
						aryPersonalData[y][10] = aryPersonalData[y][10] + 1;
						aryPersonalData[y][11] = aryPersonalData[y][11] + aryNumberOfCharacters[i];
						aryPersonalData[y][12] = aryPersonalData[y][12] + aryDeltaT[i];
					break;
					
					case aryMarkSet[4]:
						aryPersonalData[y][13] = aryPersonalData[y][13] + 1;
						aryPersonalData[y][14] = aryPersonalData[y][14] + aryNumberOfCharacters[i];
						aryPersonalData[y][15] = aryPersonalData[y][15] + aryDeltaT[i];
					break;
					
					case aryMarkSet[5]:
						aryPersonalData[y][16] = aryPersonalData[y][16] + 1;
						aryPersonalData[y][17] = aryPersonalData[y][17] + aryNumberOfCharacters[i];
						aryPersonalData[y][18] = aryPersonalData[y][18] + aryDeltaT[i];
					break;
					
					case aryMarkSet[6]:
						aryPersonalData[y][19] = aryPersonalData[y][19] + 1;
						aryPersonalData[y][20] = aryPersonalData[y][20] + aryNumberOfCharacters[i];
						aryPersonalData[y][21] = aryPersonalData[y][21] + aryDeltaT[i];
					break;
					
					default:
						
					break;
					
				}
			}
			//----------------------------------------------------------
			
			
			//----------F9の回数、文字数を配列に格納----------
			j = 0;
			k = 0; //連続するUndo回数
			y = 0;
			
			for( i = 0 ; i < aryStrings.length ; i++ ) {
				y = aryCaptioner.indexOf(aryIPAddress[i]);
				k = 0;
				
				if( aryException[3].test(aryStrings[i]) ) {
					aryPersonalData[y][22] = aryPersonalData[y][22] + 1;
					
					j = i-1;
					
					isUndo = aryException[3].test(aryStrings[j]); //「Undoの1つ前の入力」がUndoかの判定
					
					//Undoが連続する場合の処理
					while( isUndo ) {
						j--;
						isUndo = aryException[3].test(aryStrings[j]);
						k++;
					}
					aryPersonalData[y][23] = 
					aryPersonalData[y][23] + aryNumberOfCharacters[i-(2*k+1)];
				}
			}
			//------------------------------------------
			
			
			//----------F11の回数、文字数を配列に格納----------
			y = 0;
			
			for( i = 0 ; i < aryStrings.length ; i++ ) {
				y = aryCaptioner.indexOf(aryIPAddress[i]);
				
				if( aryException[1].test(aryStrings[i]) ) {
					aryPersonalData[y][24] = aryPersonalData[y][24] + 1;
					aryPersonalData[y][25] = aryPersonalData[y][25] + 1;
				}
			}
			//-------------------------------------------
			
			
			//----------入力時間合計----------
			//「最後の入力時刻」から「最初の入力時刻」を引き、さらに「対象外」と「除外対象文字列」を引く
			
			//まずは「対象外」を求める。対象外は文字数が「0」
			for( i = 0 ; i < aryNumberOfCharacters.length ; i++ ) {
				if( aryNumberOfCharacters[i] === 0 ) {
					t1 = t1 + aryDeltaT[i] * 1000;
				}
			}
			
			//「除外対象文字列」
			t1 = t1 + aryPersonalData[aryCaptioner.length][aryRank.length * 3] * 1000;
			
			//入力時間合計（ミリ秒）
			t2 = aryTime[aryTime.length - 1] - aryTime[0] - t1;
			totalTime_ms = t2;
			
			t3 = Math.floor( t2 / 3600000 );
			t4 = Math.floor( (t2 - t3 * 3600000) / 60000 );
			t5 = ( (t2 - (t3 * 3600000) - (t4 * 60000)) / 1000 ).toFixed(0);
			
			strTotalTime = t3 + "時間" + t4 + "分" + t5 + "秒";
			//-------------------------------
			
			
			
			//----------小計----------
			y = aryCaptioner.length;
			
			for( x = 1 ; x < aryRank.length * 3 + 1; x++ ) {
				for( i = 0 ; i < aryCaptioner.length ; i ++ ) {
					aryPersonalData[y][x] = aryPersonalData[y][x] + aryPersonalData[i][x];
				}
			}
			//-----------------------
			
			
			//----------入力回数合計、入力文字数合計----------
			for( i = 0 ; i < aryRank.length - 1 ; i++ ) {
				totalInput = totalInput + aryPersonalData[aryCaptioner.length][3*i+1];
				totalCaracter = totalCaracter + aryPersonalData[aryCaptioner.length][3*i+2];
			}
			
			totalInput = totalInput + 1; //最初の入力分を足す
			totalCaracter = totalCaracter + aryNumberOfCharacters[0]; //最初の入力分を足す
			//-----------------------------------------
			
			
			
			
			//----------割合----------
			y = aryCaptioner.length + 1;
			
			//
			for( x = 0 ; x < aryRank.length ; x++ ) {
				//入力回数
				aryPersonalData[y][3*x + 1] = 
				( aryPersonalData[y-1][3*x + 1] / totalInput ) * 100;
				
				//文字数
				aryPersonalData[y][3*x + 2] = 
				( aryPersonalData[y-1][3*x + 2] / totalCaracter ) * 100;
				
				//時間
				aryPersonalData[y][3*x + 3] = 
				( aryPersonalData[y-1][3*x + 3]*1000 / totalTime_ms ) *100;
			}
			//-----------------------
			
			
			//----------1分当たりの文字数----------
			charPerMinute = totalCaracter / ( totalTime_ms / (60*1000) );
			
			//----------平均入力間隔----------
			averageTime = ( totalTime_ms / totalInput ) / 1000;
			
			//----------入力1回当たりの平均表示文字数----------
			charPerInput = totalCaracter / totalInput;
			
			//****************************
			//****************************
			//****************************
			
			
			
			//********************************
			//********** HTML出力処理 **********
			//********************************
			
			
			//---------- 入力間隔マークの処理 ----------
			switch( isMark ) {
				case "1":
					break;
				
				case "2":
					for( i = 0 ; i < aryDeltaT.length ; i++ ) {
						aryMark[i] = "(" + aryDeltaT[i].toFixed(1) + ")"; //秒数を小数点1桁の「文字列」で表示
					}
					break;
				
				default:
					for( i = 0 ; i < aryDeltaT.length ; i++ ) {
						aryMark[i] = "";
					}
			}
			//-------------------------------------
			
			
			//---------- 文字列部分 ----------
			for( i = 0 ; i < aryIPAddress.length ; i++ ) {
				who = aryCaptioner.indexOf(aryIPAddress[i]);
				
				if( aryStrings[i] == "$改行$" )
				aryStrings[i] = "<br>";
				
				outputStrings = outputStrings + 
				spanColor[ who ] + aryMark[i] + aryStrings[i] + "</span>\r\n";
			}
			//------------------------------
			
			
			
			//---------- 表1 全体の統計 ----------
			strTable1 = "<div>\r\n" + 
			"<table id=\"table1\">\r\n" +
			
			"<tr>\r\n" +
			"<th>入力時間合計</th>\r\n" +
			"<td>" + strTotalTime + "</td>\r\n" +
			"</tr>\r\n" +
			
			"<tr>\r\n" +
			"<th>入力文字数合計</th>\r\n" +
			"<td>" + totalCaracter.toLocaleString() + "文字</td>\r\n" +
			"</tr>\r\n" +
			
			"<tr>\r\n" +
			"<th>入力回数合計</th>\r\n" +
			"<td>" + totalInput.toLocaleString() + "回</td>\r\n" +
			"</tr>\r\n" +
			
			"<tr>\r\n" +
			"<th>1分当たりの文字数</th>\r\n" +
			"<td>" + charPerMinute.toFixed(1) + "文字</td>\r\n" +
			"</tr>\r\n" +
			
			"<tr>\r\n" +
			"<th>平均入力間隔</th>\r\n" +
			"<td>" + averageTime.toFixed(1) + "秒</td>\r\n" +
			"</tr>\r\n" +
			
			"<tr>\r\n" +
			"<th>入力1回当たりの平均表示文字数</th>\r\n" +
			"<td>" + charPerInput.toFixed(1) + "文字</td>\r\n" +
			"</tr>\r\n" +
			"</table>\r\n" +
			"</div>\r\n";
			//---------------------------------
			
			
			//---------- 表2 ランク（秒数）ごとの統計 ----------
			strTable2 = "<div>\r\n" +
			"<table id=\"table2\">\r\n" +
			
			"<tr>\r\n" +
			"<th colspan=2 class=\"center\">間隔</th>\r\n" +
			"<th colspan=2 class=\"center\">入力回数合計</th>\r\n" +
			"<th colspan=2 class=\"center\">入力文字数合計</th>\r\n" +
			"<th colspan=2 class=\"center\">入力秒数合計</th>\r\n" +
			"</tr>\r\n";
			
			for( i = 0 ; i < aryRank.length - 1; i++ ) {
				strTable2 = strTable2 +
				"<tr>\r\n" +
				"<th>" + aryRank[i] + "秒以内" + "</th>\r\n" +
				"<th class=\"center\">" + aryMarkSet[i] + "</th>\r\n" +
				
				"<td>" + 
				aryPersonalData[aryCaptioner.length][3*i + 1].toLocaleString() + 
				"回</td>\r\n" +
				
				"<td>" +
				aryPersonalData[aryCaptioner.length+1][3*i +1].toFixed(1) +
				"%</td>\r\n" +
				
				"<td>" + 
				aryPersonalData[aryCaptioner.length][3*i + 2].toLocaleString() + 
				"文字</td>\r\n" +
				
				"<td>" +
				aryPersonalData[aryCaptioner.length+1][3*i +2].toFixed(1) +
				"%</td>\r\n" + 
				
				"<td>" + 
				parseFloat( 
				aryPersonalData[aryCaptioner.length][3*i + 3].toFixed(1) ).toLocaleString() + 
				"秒</td>\r\n" +
				
				"<td>" +
				aryPersonalData[aryCaptioner.length+1][3*i +3].toFixed(1) +
				"%</td>\r\n" +
				"</tr>\r\n";
				
			}
			
			i = aryRank.length -1;
			
			strTable2 = strTable2 +
			"<tr>\r\n" +
			"<th>" + aryRank[i] + "</th>\r\n" +
			"<th class=\"center\">" + aryMarkSet[i] + "</th>\r\n" +
			
			"<td>" + 
			aryPersonalData[aryCaptioner.length][3*i + 1].toLocaleString() + 
			"回</td>\r\n" +
			
			"<td>" +
			aryPersonalData[aryCaptioner.length+1][3*i +1].toFixed(1) +
			"%</td>\r\n" +
			
			"<td>" + 
			aryPersonalData[aryCaptioner.length][3*i + 2].toLocaleString() + 
			"文字</td>\r\n" +
			
			"<td>" +
			aryPersonalData[aryCaptioner.length+1][3*i +2].toFixed(1) +
			"%</td>\r\n" + 
			
			"<td>" + 
			parseFloat( 
			aryPersonalData[aryCaptioner.length][3*i + 3].toFixed(1)).toLocaleString() + 
			"秒</td>\r\n" +
			
			"<td>" +
			aryPersonalData[aryCaptioner.length+1][3*i +3].toFixed(1) +
			"%</td>\r\n" +
			"</tr>\r\n" +
			"</table>\r\n" +
			"</div>\r\n";
			//--------------------------------------------
			
			
			//---------- 表3 入力者ごとの統計1 ----------
			strTable3 = "<div>\r\n" +
			"<table id=\"table3\">\r\n" +
			
			"<tr>\r\n" +
			"<th class=\"center\">入力者</th>\r\n" +
			"<th colspan=2 class=\"center\">入力回数</th>\r\n" +
			"<th colspan=2 class=\"center\">入力文字数</th>\r\n" +
			"<th colspan=2 class=\"center\">F9（Undo）</th>\r\n" +
			"<th colspan=2 class=\"center\">F11（DEL）</th>\r\n";
			
			
			strTable3 = strTable3 +
			"</tr>\r\n";
			
			
			for( i = 0 ; i < aryCaptioner.length ; i++ ) {
				
				var temp = 0; //入力文字数カウント用
				
				for( j = 0 ; j < aryRank.length ; j++ ) {
					aryPersonalData[i][26] = aryPersonalData[i][26] + aryPersonalData[i][3*j + 1];
					temp = temp + aryPersonalData[i][3*j + 2];
				}
				
				strTable3 = strTable3 +
				"<tr " + "class=\"color" + i + "\">\r\n" +
				"<th>" +aryCaptioner[i] + "</th>\r\n" +
				"<td>" + aryPersonalData[i][26] + "回</td>\r\n" +
				"<td>" + ( ( aryPersonalData[i][26] / totalInput ) * 100 ).toFixed(1) + "%</td>\r\n" +
				"<td>" + temp.toLocaleString()  + "文字</td>\r\n" +
				"<td>" + ( ( temp / totalCaracter ) * 100 ).toFixed(1) + "%</td>\r\n" +
				"<td>" + aryPersonalData[i][22] + "回</td>\r\n" +
				"<td>" + aryPersonalData[i][23] + "文字</td>\r\n" +
				"<td>" + aryPersonalData[i][24] +  "回</td>\r\n" +
				"<td>" + aryPersonalData[i][25] +  "文字</td>\r\n";
				
				strTable3 = strTable3 +
				"</tr>\r\n";
				
			}
			
			strTable3 = strTable3 +
			"</table>\r\n" +
			"</div>\r\n";
			//---------------------------------------
			
			
			//---------- 表4 入力者ごとの統計2 ----------
			strTable4 = "<div>\r\n" +
			"<table id=\"table4\">\r\n" +
			
			"<tr>\r\n" +
			"<th class=\"center\">入力者</th>\r\n";
			
			for( i = 0 ; i < aryMarkSet.length ; i++ ) {
				strTable4 = strTable4 +
				"<th colspan=2 class=\"center\">" + aryMarkSet[i] + "</th>\r\n";
			}
			
			strTable4 = strTable4 +"</tr>\r\n";
			
			for( i = 0 ; i < aryCaptioner.length ; i++ ) {
				
				strTable4 = strTable4 +
				"<tr " + "class=\"color" + i + "\">\r\n" +
				"<th>" +aryCaptioner[i] + "</th>\r\n";
				
				for( k = 0 ; k < aryRank.length ; k++ ) {
					strTable4 = strTable4 +
					"<td>" + aryPersonalData[i][3*k + 1] + "回</td>\r\n" +
					"<td>" + 
					( ( aryPersonalData[i][3*k + 1] / aryPersonalData[i][26] ) * 100 ).toFixed(1) + 
					"%</td>\r\n";
				}
				strTable4 = strTable4 +"</tr>\r\n";
			}
			
			
			strTable4 = strTable4 +
			"</table>\r\n" +
			"</div>\r\n";
			//---------------------------------------
			
			
			
			document.getElementById("results").value = 
			strHeader + strCSS1 + strCSS2 + strBodyStart +
			outputStrings + "</p>\r\n" + 
			strTable1 + strTable2 + strTable3 + strTable4 +
			"</body>\r\n" + "</html>";
			
			
			//*********************************
			//*********************************
			//*********************************
			
		};
	
	}
	
	//File APIをサポートしていない場合は終了
	else {
		alert('ご使用のブラウザには対応していません。');
	}

}


//ファイル未選択状態にする。テキストエリアも初期状態に。
function reset() {
	document.getElementById("selectedFile").value = "";
	document.getElementById("results").value = "ここに結果が表示されます。";
}
